
function setup()
    map:init(0, 0, 50, 50, 50, 200, 100)
    inventory:init(HEIGHT/2, WIDTH/2, 12)
    joystick:init(WIDTH/2 - 105, HEIGHT/2 - 125, 125)
    player:init()
    UI:init()
    animationTime = 0
    zoom = 0
    touches = {}
end
function touched(touch)
    touches[touch.id] = touch
    for i, n in pairs(touches) do
        inventory:touched(n)
        joystick:touched(n)
        UI:touched(n)
    end
end
function draw()
    background(0)
    
    --camera
    zoom = math.max(math.min(zoom, 35), 0)
    camera(WIDTH/2, HEIGHT/2 - (zoom * 25), 1000 + (zoom * 10), WIDTH/2, HEIGHT/2 , -zoom)
    perspective(45, WIDTH/HEIGHT, 0.1, 2000)

    --map transform
    pushMatrix()
    translate(-playerX, -playerY)
    map:draw()
    --player sep from movement but included in scale matrix
    popMatrix()
    player:draw()
    viewMatrix(matrix())
    ortho()
    
    --UI
    joystick:draw()
    inventory:draw()
    UI:draw()
end

