joystick = class()

function joystick:init( x, y, size)
    self.size = size
    self.x = x
    self.y = y
    self.handleX = self.x
    self.handleY = self.y
    joystickAngle = 0
    angleInDegrees = 0
    self.touchDistance = 0
    self.joystickLimit = self.size/2
    moving = false
    self.touchI = nil
end

function joystick:draw()
    angleInDegrees = math.deg(joystickAngle) + 180
    -- joystick base
    pushStyle()
    fill(38, 29, 23, 125)
    stroke(0)
    strokeWidth(1)
    ellipse(self.x, self.y, self.size)
    popStyle()
    --joystick handle
    pushStyle()
    fill(60, 42, 29, 100)
    stroke(0)
    strokeWidth(1)
    ellipse( self.handleX, self.handleY, self.size/2.5)
    popStyle()
end

function joystick:touched(touch)
    
    if self.touchI then 
        self.touchDistance = math.sqrt(((touches[self.touchI].pos.x - self.x) ^ 2) + ((touches[self.touchI].pos.y - self.y) ^ 2))
        if touches[self.touchI].state == ENDED then
            self.handleX = self.x
            self.handleY = self.y
            moving = false
            self.touchI = nil
        end
    else
        self.touchDistance = math.sqrt(((touch.pos.x - self.x) ^ 2) + ((touch.pos.y - self.y) ^ 2))
        if touch.state == BEGAN and self.touchDistance < self.joystickLimit + 50 then
            self.touchI = touch.id
            moving = true
        end
    end
    
    if moving then
        joystickAngle = math.atan(self.x - touches[self.touchI].pos.x, self.y - touches[self.touchI].pos.y)
        if self.touchDistance > self.joystickLimit then
            self.handleX = self.x + (self.size / 2) * math.cos(-joystickAngle - 1.5)
            self.handleY = self.y + (self.size / 2) * math.sin(-joystickAngle - 1.5) 
        else
            self.handleX = touches[self.touchI].pos.x
            self.handleY = touches[self.touchI].pos.y
        end
    end
end
