player = class()

function player:init()
    playerX = 0
    playerY = 0
    self.clip = vec2(WIDTH, HEIGHT)
    self.size = 10
    self.speed = 2
    self.direction = 0
    self.animationTime = 0
    self.runningSprite = {}
    self.runningSprite[2] = animator:init(asset.playerAnimations.player_RunRight, 33, 64, 4)
    
    self.runningSprite[0] = animator:init(asset.playerAnimations.player_RunDown, 33, 64, 4)
    
    self.runningSprite[3] = animator:init(asset.playerAnimations.player_RunRight, 33, 64, 4)
    
    self.runningSprite[1] = animator:init(asset.playerAnimations.player_RunRight, 33, 64, 4)
    
    self.standingSprite = animator:init(asset.playerAnimations.player_standing, 33, 64, 4)
end

function player:draw()
    -- look direction
    if  angleInDegrees > 55 and angleInDegrees < 125 then
        self.direction = 2
    end
    if  angleInDegrees > 145 and angleInDegrees < 215 then
        self.direction = 0
    end 
    if angleInDegrees > 235 and angleInDegrees < 305 then
        self.direction = 3
    end
    if angleInDegrees > 335 or angleInDegrees < 35 then
        self.direction = 1
    end
    if moving then
        playerX = playerX + self.speed * math.cos(-joystickAngle - 1.5)
        playerY = playerY + self.speed * math.sin(-joystickAngle - 1.5) 
        
    end
    pushStyle()
    pushMatrix()
    stroke(255, 14, 0)
    strokeWidth(2)
    fill(255, 0)
    rectMode(CENTER)
    rect(WIDTH/2 ,HEIGHT/2 ,15,30)
    if moving then
        self.animationTime = self.animationTime + (DeltaTime * 8)
        if self.animationTime > 4 then
            self.animationTime = 0
        end
        sprite(self.runningSprite[self.direction][math.floor(self.animationTime) + 1], WIDTH / 2, HEIGHT / 2)
    else
        sprite(self.standingSprite[self.direction + 1], WIDTH / 2, HEIGHT / 2)
        self.animationTime = 0
    end
    clip()
    popMatrix()
    popStyle()
end